<template>
  <div>
    <b-container class="UserManager">
      <div v-if="this.edit === false && this.add === false" id="change">
        <b-row>
          <b-col cols="12">
            <b-table
              :current-page="currentPage"
              :per-page="perPage"
              :pagination="true"
              hover
              small
              :items="info"
              :fields="fields"
            >
              <template #cell(change)="row" :infos="this.infos">
                <b-button
                  size="sm"
                  variant="primary"
                  :disabled="(row.item.role === 'manager' && infos != 'admin') || row.item.role === 'admin'"
                  @click="change(row.item.id, row.item.role)"
                  class="mr-1"
                >
                  <font-awesome-icon icon="user-tag"></font-awesome-icon>
                </b-button>
              </template>
              <template #cell(actions)="row" :infos="this.infos">
                <b-button
                  size="sm"
                  variant="danger"
                  :disabled="(row.item.role === 'manager' && infos != 'admin') || row.item.role === 'admin'"
                  @click="deletes(row.item.id)"
                  class="mr-1"
                >
                  <b-icon icon="trash-fill" aria-hidden="true"></b-icon>
                </b-button>
              </template>

              <template #cell(edit)="row" v-bind:id="this.id" :infos="this.infos">
                <b-button
                  size="sm"
                  variant="primary"
                  @click="editUser(row.item.id)"
                  :disabled="(row.item.role === 'manager' && row.item.id != id && infos != 'admin') || (row.item.role === 'admin' && row.item.id != id)"
                  class="mr-1"
                >
                  <font-awesome-icon icon="edit" />
                </b-button>
              </template>
            </b-table>
          </b-col>
        </b-row>

        <b-row class="text-right">
          <b-col cols="6">
            <b-pagination
              id="page"
              v-model="currentPage"
              :total-rows="info.length"
              :per-page="perPage"
              align="fill"
              size="sm"
            ></b-pagination>
          </b-col>

          <b-col cols="2">
            <b-button variant="success" @click="showAdd()" id="margin"
              ><font-awesome-icon icon="plus-square" /> add User</b-button
            >
          </b-col>
        </b-row>
      </div>

      <div id="edit" v-if="this.edit === true">
        <h1>Edit user</h1>
        <b-container fluid id="parent">
          <div id="username">
            <label for="input-default">Username:</label>
            <b-form-input
              id="input-default"
              type="email"
              placeholder="Enter username"
              v-model="username"
            ></b-form-input>
          </div>
          <div id="email">
            <label for="input-default">Email:</label>
            <b-form-input
              id="input-default"
              type="email"
              placeholder="Enter user's email"
              v-model="email"
            ></b-form-input>
          </div>
        </b-container>
        <b-button variant="success" @click="edits()"> Edit user </b-button>
      </div>
      <div v-if="this.add === true">
        <b-container fluid id="input">
          <b-row class="my-1">
            <b-col sm="2">
              <label for="input-default">Username:</label>
            </b-col>
            <b-col sm="10">
              <b-form-input
                id="input-default"
                placeholder="Enter your name"
                v-model="username"
              ></b-form-input>
            </b-col>
          </b-row>

          <b-row class="my-1">
            <b-col sm="2">
              <label for="input-default">Email:</label>
            </b-col>
            <b-col sm="10">
              <b-form-input
                id="input-default"
                type="email"
                placeholder="Enter your email"
                v-model="email"
              ></b-form-input>
            </b-col>
          </b-row>

          <b-row class="my-1">
            <b-col sm="2">
              <label for="input-default">Password:</label>
            </b-col>
            <b-col sm="10">
              <b-form-input
                id="input-default"
                type="password"
                placeholder="Enter your password"
                v-model="password"
              ></b-form-input>
            </b-col>
          </b-row>
          <b-button variant="success" @click="postUser()"
            >Register account</b-button
          >
        </b-container>
      </div>
    </b-container>
  </div>
</template>

<script>
import { PaginationPlugin } from "bootstrap-vue";
import config from "@/Utils/config.json";
Vue.use(PaginationPlugin);
import axios from "axios";
import Vue from "vue";
import { BButton, BFormSelect, BFormInput, BFormRadio } from "bootstrap-vue";
import { FontAwesomeIcon } from "@fortawesome/vue-fontawesome";
import {
  faTrash,
  faEdit,
  faPlusSquare,
  faUserTag,
} from "@fortawesome/free-solid-svg-icons";
import { library } from "@fortawesome/fontawesome-svg-core";
import "bootstrap/dist/css/bootstrap.css";
import "bootstrap-vue/dist/bootstrap-vue.css";
Vue.component("b-form-select", BFormSelect);
Vue.component("b-button", BButton);
Vue.component("b-form-input", BFormInput);
Vue.component("b-form-radio", BFormRadio);
library.add(faTrash);
library.add(faEdit);
library.add(faPlusSquare);
library.add(faUserTag);
Vue.component("font-awesome-icon", FontAwesomeIcon);
import { getUserId } from "@/router/auth.js";


export default {
  name: "Managers",
  data() {
    return {
      edit: false,
      id: getUserId(),
      perPage: 5,
      currentPage: 1,
      mappedInfos: [],
      fields: [
        { key: "id", label: "ID" },
        { key: "username", label: "Username" },
        { key: "email", label: "Email" },
        { key: "role", label: "Role" },
        { key: "change", label: "Change Role" },
        { key: "actions", label: "Delete" },
        { key: "edit", label: "Edit" },
      ],
      info: {},
      infos: "",
      userid: "",
      username: "",
      email: "",
      password: "",
      add: false,
    };
  },
  methods: {
    async change(id, role) {
      if (role === "user") {
        await axios.put(
          `${config.config.res_endpoint}api/manager/${id}`,
          {},
          {
            headers: {
              Authorization: "Bearer " + localStorage.getItem("accesToken"),
            },
          }
        );
        await axios
          .get(`${config.config.res_endpoint}api/users`, {
            headers: {
              Authorization: "Bearer " + localStorage.getItem("accesToken"),
            },
          })
          .then((response) => {
            this.info = response.data.data;
          });
      } else if (role === "manager") {
        await axios.put(
          `${config.config.res_endpoint}api/users/${id}`,
          {
            user: {
              role: "user",
            },
          },

          {
            headers: {
              Authorization: "Bearer " + localStorage.getItem("accesToken"),
            },
          }
        );
        await axios
          .get(`${config.config.res_endpoint}api/users`, {
            headers: {
              Authorization: "Bearer " + localStorage.getItem("accesToken"),
            },
          })
          .then((response) => {
            this.info = response.data.data;
          });
      }
    },
    editUser: function (id) {
      this.userid = id;
      return (this.edit = true);
    },
    async deletes(id) {
      this.userid = id;
      await axios.delete(`${config.config.res_endpoint}api/users/${this.userid}`, {
        headers: {
          Authorization: "Bearer " + localStorage.getItem("accesToken"),
        },
      });
      await axios
        .get(`${config.config.res_endpoint}api/users`, {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        })
        .then((response) => {
          this.info = response.data.data;
        });
    },
    async edits() {
      this.edit = false;
      await axios.put(
        `${config.config.res_endpoint}api/users/${this.userid}`,
        {
          user: {
            username: this.username,
            email: this.email,
          },
        },

        {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        }
      );
      await axios
        .get(`${config.config.res_endpoint}api/users`, {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        })
        .then((response) => {
          this.info = response.data.data;
        });
      this.username = "";
      this.email = "";
    },
    showAdd() {
      this.add = true;
    },
    async postUser() {
      this.add = false;
      var bodyFormData = new FormData();
      bodyFormData.append(this.username, this.email);
      await axios.post(`${config.config.res_endpoint}api/users/`, {
        user: {
          username: "" + this.username,
          email: "" + this.email,
          password: "" + this.password,
        },
      });
      await axios
        .get(`${config.config.res_endpoint}api/users`, {
          headers: {
            Authorization: "Bearer " + localStorage.getItem("accesToken"),
          },
        })
        .then((response) => {
          this.info = response.data.data;
        });
      this.email = "";
      this.username = "";
      this.password = "";
    },
  },
  mounted() {
    axios
      .get(`${config.config.res_endpoint}api/users`, {
        headers: {
          Authorization: "Bearer " + localStorage.getItem("accesToken"),
        },
      })
      .then((response) => {
        this.info = response.data.data;
        this.mappedInfos = this.info.map((info) => {
          return { value: info.id, text: info.username };
        });
      });
    axios
      .get(`${config.config.res_endpoint}api/users/${getUserId()}`, {
        headers: {
          Authorization: "Bearer " + localStorage.getItem("accesToken"),
        },
      })
      .then((response) => {
        this.infos = response.data.role;
      });
  },
};
</script>

<style scoped>
#change {
  text-align: center;
}

#edit {
  text-align: center;
}

#margin {
  margin-bottom: 10px;
}

#page {
  margin-left: 0% !important;
}
</style>